package dev.reactant.reactantcli.commands.generate.command

import dev.reactant.reactantcli.commands.TemplateRepository
import org.slf4j.LoggerFactory
import picocli.CommandLine


@CommandLine.Command(
    name = "command",
    aliases = ["cmd"],
    description = ["Generate a command class"]
)
class GenerateCommandClassCommand : Runnable {
    override fun run() {
        val dataModel = hashMapOf(
            "commandName" to commandName,
            "alias" to alias.joinToString(",") { "\"$it\"" },
            "desc" to desc.joinToString(",") { "\"$it\"" },
            "package" to classPath.split(".").let { if (it.size > 1) it.dropLast(1).joinToString(".") else "" },
            "className" to classPath.split(".").last()
        )
        TemplateRepository.writeTemplate(
            "type/command/Command.kt",
            "src/main/kotlin/${classPath.split(".").joinToString("/")}.kt",
            dataModel
        );
    }

    private val logger = LoggerFactory.getLogger(this.javaClass)

    @CommandLine.Parameters(arity = "1", paramLabel = "FULL_CLASS_PATH")
    var classPath: String = ""

    @CommandLine.Option(
        names = ["-n", "--name"],
        paramLabel = "NAME",
        description = ["the name of command",
            "default is generated by class name"]
    )
    var specifyCommandName: String = ""
    private val commandName
        get() = if (specifyCommandName != "") specifyCommandName else classPath.split(".").last().let {
            if (it.endsWith("Command")) it.removeSuffix("Command") else it
        }.toLowerCase()

    @CommandLine.Option(names = ["-a", "--alias"], split = ",")
    var alias: Array<String> = arrayOf();

    @CommandLine.Option(names = ["-d", "--desc"], split = ",")
    var desc: Array<String> = arrayOf();
}
